LeetCode——748. 最短补全词(Java)

题目描述

题干:
给你一个字符串 licensePlate 和一个字符串数组 words ,请你找出并返回 words 中的 最短补全词 。
补全词 是一个包含 licensePlate 中所有的字母的单词。在所有补全词中,最短的那个就是 最短补全词 。
在匹配 licensePlate 中的字母时:
忽略 licensePlate 中的 数字和空格 。
不区分大小写。
如果某个字母在 licensePlate 中出现不止一次,那么该字母在补全词中的出现次数应当一致或者更多。
例如:licensePlate = "aBc 12c",那么它的补全词应当包含字母 'a'、'b' (忽略大写)和两个 'c' 。
题目数据保证一定存在一个最短补全词。当有多个单词都符合最短补全词的匹配条件时取 words 中 最靠前的 那个。

示例 1:
输入:licensePlate = "1s3 PSt", words = ["step", "steps", "stripe", "stepple"]
输出:"steps"
解释:最短补全词应该包括 "s"、"p"、"s"(忽略大小写) 以及 "t"。
"step" 包含 "t"、"p",但只包含一个 "s",所以它不符合条件。
"steps" 包含 "t"、"p" 和两个 "s"。
"stripe" 缺一个 "s"。
"stepple" 缺一个 "s"。
因此,"steps" 是唯一一个包含所有字母的单词,也是本例的答案。

示例 2:
输入:licensePlate = "1s3 456", words = ["looks", "pest", "stew", "show"]
输出:"pest"
解释:licensePlate 只包含字母 "s" 。其中 "pest"、"stew"、和 "show" 三者最短并且 "pest" 是三个单词中在 words 里最靠前的那个。

示例 3:
输入:licensePlate = "Ah71752", words = ["suggest","letter","of","husband","easy","education","drug","prevent","writer","old"]
输出:"husband"

示例 4:
输入:licensePlate = "OgEu755", words = ["enough","these","play","wide","wonder","box","arrive","money","tax","thus"]
输出:"enough"

示例 5:
输入:licensePlate = "iMSlpe4", words = ["claim","consumer","student","camera","public","never","wonder","simple","thought","use"]
输出:"simple"

题解思路

找到其中最短补全词,其实就是找到最少能补全licensePlate 元素,直接哈希表或者用集合记录个数比较即可

因为题干说明一定存在结果,所以我们最后不需要考虑找不到的情况,并且注意要找到第一个最短的元素即可

正确代码

public String shortestCompletingWord(String licensePlate, String[] words) {
    int[] cnt = new int[26];

    for (int i = 0; i < licensePlate.length(); i++) {
        char c = licensePlate.charAt(i);
        if (Character.isLetter(c)) {
            cnt[Character.toLowerCase(c) - 'a']++;
        }
    }

    int idx = -1;
    for (int i = 0; i < words.length; i++) {
        int[] c = new int[26];
        for (int j = 0; j < words[i].length(); j++) {
            char ch = words[i].charAt(j);
            c[ch - 'a']++;
        }

        boolean ok = true;
        for (int j = 0; j < 26; j++) {
            if (c[j] < cnt[j]) {
                ok = false;
                break;
            }
        }
        if (ok && (idx < 0 || words[i].length() < words[idx].length())) {
            idx = i;
        }
    }
    return words[idx];
}

总结

记得当时刚学会哈希表,遇到这种问题就一股脑往上用,就感觉哈希表无所不能且十分好用

现在感觉如果能用更加简单的数据结构来完成的,一定要用最原始的方法解决,恨不得全用二进制来做

如果文章存在问题或者有其他更好的题解,欢迎在评论区斧正和评论,各自努力,最高处见
posted @ 2021-12-10 10:10  21岁还不是架构师  阅读(56)  评论(0编辑  收藏  举报